//this.statusImage.addEventListener("click", wexecute('Ghost'), false);

//var el = document.getElementById("gfox"); 
//el.addEventListener("click", function(e) { GhostFox.wExecute(); }, false);


/*write backup:	
	-|Restores the default values copied from firefox.
FUNCTION writeBCK START
*/
function writeBck(){

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	//Char Prefs
	
	prefs.setCharPref("browser.display.background_color",prefs.getCharPref("extensions.ghostfox.display.background_color"));
	prefs.setCharPref("browser.display.force_background_color",prefs.getCharPref("extensions.ghostfox.display.focus_background_color"));
	prefs.setCharPref("browser.display.focus_text_color",prefs.getCharPref("extensions.ghostfox.display.focus_text_color"));
	prefs.setCharPref("browser.display.foreground_color",prefs.getCharPref("extensions.ghostfox.display.foreground_color"));	
	prefs.setCharPref("browser.active_color",prefs.getCharPref("extensions.ghostfox.active_color"));
	prefs.setCharPref("browser.anchor_color",prefs.getCharPref("extensions.ghostfox.anchor_color"));
	prefs.setCharPref("browser.visited_color",prefs.getCharPref("extensions.ghostfox.visited_color"));
	

	//Bool Prefs
	
	prefs.setBoolPref("browser.display.show_image_placeholders",prefs.getBoolPref("extensions.ghostfox.display.show_image_placeholders"));
	prefs.setBoolPref("browser.display.use_document_colors",prefs.getBoolPref("extensions.ghostfox.display.use_document_colors"));
	prefs.setBoolPref("browser.display.use_focus_colors",prefs.getBoolPref("extensions.ghostfox.display.use_focus_colors"));
	prefs.setBoolPref("browser.display.use_system_colors",prefs.getBoolPref("extensions.ghostfox.display.use_system_colors"));

	//Int Prefs
	prefs.setIntPref("permissions.default.image",prefs.getIntPref("extensions.ghostfox.default.image"));
	prefs.setIntPref("browser.display.use_document_fonts",prefs.getIntPref("extensions.ghostfox.display.use_document_fonts"));


}
//FUNCTION writeBCK END
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/*function colorize
	-|writes the color information from ghostfox internal prefs to browser values
FUNCTION COLORIZE START
*/
function coloRize(){

	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	//write color values
	prefs.setCharPref("browser.display.foreground_color",prefs.getCharPref("extensions.ghostfox.foreground"));
	prefs.setCharPref("browser.display.background_color",prefs.getCharPref("extensions.ghostfox.background"));
	prefs.setCharPref("browser.anchor_color",prefs.getCharPref("extensions.ghostfox.link"));
	prefs.setCharPref("browser.active_color",prefs.getCharPref("extensions.ghostfox.alink"));
	prefs.setCharPref("browser.visited_color",prefs.getCharPref("extensions.ghostfox.vlink"));
	prefs.setCharPref("browser.display.focus_background_color",prefs.getCharPref("extensions.ghostfox.element"));
	prefs.setCharPref("browser.display.focus_text_color",prefs.getCharPref("extensions.ghostfox.focustext"));
	
	//write usage values
	prefs.setBoolPref("browser.display.use_focus_colors","1");
	prefs.setBoolPref("browser.display.use_document_colors","0");
	prefs.setBoolPref("browser.display.use_system_colors","0");
	

}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*Style 1
	-|Normal display. keep default values. Just call write backup.
FUNCTION STYLE1 START
*/
function style1(){

	writeBck();

}
//FUNCTION STYLE1 END

////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*Style 2
	-|Color changes alone
FUNCTION STYLE2 START
*/
function style2(){

	writeBck();
	coloRize();

}

//FUNCTION STYLE2 END

////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*Style 3
	-|Color change
	-|Remove Images
FUNCTION STYLE3 START
*/
function style3(){

	writeBck();
	coloRize();
	
	//set image display to false + image placeholders to false
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	prefs.setIntPref("permissions.default.image","2");
	prefs.setBoolPref("browser.display.show_image_placeholders","0");
	

}

//FUNCTION STYLE3 END

////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*Style 4
	-|Color change
	-|Remove Images
FUNCTION STYLE4 START
*/
function style4(){

	writeBck();
	coloRize();
	
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	//set background=foreground
	prefs.setCharPref("browser.display.foreground_color","#FFFFFF");
	prefs.setCharPref("browser.display.focus_text_color","#FFFFFF");
	prefs.setCharPref("browser.anchor_color","#FFFFFF");
	prefs.setCharPref("browser.active_color","#FFFFFF");
	prefs.setCharPref("browser.visited_color","#FFFFFF");
	
	//set image display to false + image placeholders to false
	prefs.setIntPref("permissions.default.image","2");
	prefs.setBoolPref("browser.display.show_image_placeholders","0");
	

}

//FUNCTION STYLE4 END

/*Function stylizer
	-|Identify and execute style
*/
function styliZer(){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var l=prefs.getIntPref("extensions.ghostfox.style");
	
	if(l=="1"){style1();}
	if(l=="2"){style2();}
	if(l=="3"){style3();}
	if(l=="4"){style4();}

}
//FUNCTION STYLIZER END

function wExecute(e)
{

//check for first-run
//wInitPrefs();
//var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	/* ::: Fix the directory service and local file interface to the winampcc executable ::: */
	var directoryService=Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var wFile = directoryService.get('ProfD', Components.interfaces.nsILocalFile);

	/*set ghosting prefs.
	prefs.setCharPref("browser.display.focus_text_color","#808080");
	prefs.setCharPref("browser.display.foreground_color","#FFFFFF");
	prefs.setCharPref("browser.display.background_color","#808080");
	prefs.setCharPref("browser.active_color","#808080");
	prefs.setCharPref("browser.anchor_color","#808080");
	prefs.setCharPref("browser.visited_color","#808080");
	prefs.setCharPref("browser.display.focus_background_color","#FFFFFF");
	prefs.setCharPref("browser.display.background_color","#FFFFFF");
                                       	
	/* ::: Define the path do the exe ::: */

	wFile.append("extensions");
	wFile.append("{BD383794-1BB4-4a67-BC47-EE35403776FB}");
      var img = document.getElementById("gfox-image");
      if (!img) return;
	var src = img.getAttribute("bust");

      if (src == "f")
	{
	//call stylizer

	styliZer();

	wFile.append("Ghostfox_be.exe");
	//prefs.setBoolPref("browser.display.use_document_colors",false);
	img.setAttribute("bust","t");
	img.setAttribute("tooltiptext","Bust");
	}
	else
	{
	writeBck();
	wFile.append("Ghostfox_kill.exe");
	//prefs.setBoolPref("browser.display.use_document_colors",true);
	img.setAttribute("bust","f");
	img.setAttribute("tooltiptext","Ghost");
	}

	/* ::: Inititate the process ::: */
	var wProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess);

	wProcess.init(wFile);
	
	/* ::: Just do it.. :) ::: */
	wCommand = "a";
	
	
		wProcess.run(false,[wCommand],1);


}

/*
                                                     
 (           )                 )   (                  
 )\ )     ( /(              ( /(   )\ )            )  
(()/(     )\())   (    (    )\()) (()/(    (    ( /(  
 /(_))_  ((_)\    )\   )\  (_))/   /(_))   )\   )\())   
(_)) __| | |(_)  ((_) ((_) | |_   (_) _|  ((_) ((_)\   
  | (_ | | ' \  / _ \ (_-< |  _|   |  _| / _ \ \ \ /  
   \___| |_||_| \___/ /__/  \__|   |_|   \___/ /_\_\  
							
TO BE RUN ONLY ONCE AFTER INSTALLATION                                                      
*/


function initializeOverlay(){
	const ver="0.2.0.0";
	var exp="";
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	try{
	exp=prefs.getCharPref("extensions.ghostfox.version");
	} catch(e){}
	if(exp!=ver){
		

			//Write all internal prefs
			//Char pref
			prefs.setCharPref("extensions.ghostfox.foreground","#C0C0C0");
			prefs.setCharPref("extensions.ghostfox.background","#FFFFFF");
			prefs.setCharPref("extensions.ghostfox.link","#C0C0C0");
			prefs.setCharPref("extensions.ghostfox.alink","#C0C0C0");
			prefs.setCharPref("extensions.ghostfox.vlink","#C0C0C0");
			prefs.setCharPref("extensions.ghostfox.element","#FFFFFF");
			prefs.setCharPref("extensions.ghostfox.focustext","#C0C0C0");
			//Int pref
			prefs.setIntPref("extensions.ghostfox.displayimage","2");
			prefs.setIntPref("extensions.ghostfox.style","3");
			//Bool pref
			prefs.setBoolPref("extensions.ghostfox.reload","0");
			
		//Simultaneous read/write
		
		//Char Prefs
		prefs.setCharPref("extensions.ghostfox.display.background_color",prefs.getCharPref("browser.display.background_color"));
	
		prefs.setCharPref("extensions.ghostfox.display.focus_background_color",prefs.getCharPref("browser.display.focus_background_color"));
	
		prefs.setCharPref("extensions.ghostfox.display.focus_text_color",prefs.getCharPref("browser.display.focus_text_color"));
		prefs.setCharPref("extensions.ghostfox.display.foreground_color",prefs.getCharPref("browser.display.foreground_color"));
		prefs.setCharPref("extensions.ghostfox.active_color",prefs.getCharPref("browser.active_color"));
		prefs.setCharPref("extensions.ghostfox.anchor_color",prefs.getCharPref("browser.anchor_color"));
		prefs.setCharPref("extensions.ghostfox.visited_color",prefs.getCharPref("browser.visited_color"));
		//Bool Prefs
		prefs.setBoolPref("extensions.ghostfox.display.show_image_placeholders",prefs.getBoolPref("browser.display.show_image_placeholders"));
		prefs.setBoolPref("extensions.ghostfox.display.use_document_colors",prefs.getBoolPref("browser.display.use_document_colors"));
		prefs.setBoolPref("extensions.ghostfox.display.use_focus_colors",prefs.getBoolPref("browser.display.use_focus_colors"));
		prefs.setBoolPref("extensions.ghostfox.display.use_system_colors",prefs.getBoolPref("browser.display.use_system_colors"));
		//Int Prefs
		prefs.setIntPref("extensions.ghostfox.default.image",prefs.getIntPref("permissions.default.image"));
		prefs.setIntPref("extensions.ghostfox.display.use_document_fonts",prefs.getIntPref("browser.display.use_document_fonts"));
		


	prefs.setCharPref("extensions.ghostfox.version",ver);
	}
}

window.addEventListener("load", initializeOverlay, false);
